public class FPA {
  public static final long PI_BY_2 = 102944;
  public static final long PI      = 205887;
  public static final long _2_PI   = 411775;

  long value=0;
  
  public FPA(){}
  public FPA(long val) {
    value = val; 
  }
  public FPA(double val){
    value = (long)(value << 16);
  }

  public void add (long a){
    value = value + a;
  }

  public void sub (long a){
    value = value - a;
  }
  
  public void mul (long a){
    value = value * a >>16 ;
  }

  public void div (long a){
    value = (value << 16) / a;
  }
  
  public void add (FPA a){
    this.add(a.value);
  }

  public void sub (FPA a){
    this.sub(a.value);
  }

  public void mul (FPA a){
    this.mul(a.value);
  }

  public void div (FPA a){
    this.div(a.value);
  }
 
  public double todouble() {
    return value>>16;
  }
  
  public void sin(){
    if (value < 0) {
      value = -value;
      this.sin();
      value = - value;
    } else {
      if (value>FPA.PI_BY_2) {
          value = (FPA.PI - value);
          this.sin();
      } else {
        FPA x2 = FPA.mul(this, this);
        FPA x3 = FPA.mul(this, x2);
        FPA x5 = FPA.mul(x2, x3);
        FPA x7 = FPA.mul(x2, x5);
        value = (value - (x3.value)/6 + (x5.value)/120 - (x7.value)/5040);
      }
    }
  }

  public void cos(){
    value = value + FPA.PI_BY_2;
    if (value > PI) value = value - FPA._2_PI;
    this.sin();
  }
  
  public static FPA add(FPA a, FPA b) {
    FPA temp = new FPA(a.value+b.value); 
    return temp;
  }

  public static FPA sub(FPA a, FPA b) {
    FPA temp = new FPA(a.value-b.value);
    return temp;
  }
  
  public static FPA mul(FPA a, FPA b) {
    return new FPA((a.value*b.value)>>16);
  }

  public static FPA div(FPA a, FPA b) {
    return new FPA((a.value<<16)/b.value);
  }
  
  public static FPA sin(FPA x) { 
    FPA temp = new FPA (x.value);
    temp.sin();
    return temp;
  }

  public static FPA cos(FPA x) {
    FPA temp = new FPA (x.value);
    temp.cos();
    return temp;
  }
  
  public static void main (String [] args){
    System.out.println(cos(new FPA(-10450)).value);
  }
}

