unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type point = record
x, y: integer;
end;

type
  TForm1 = class(TForm)
    Image1: TImage;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    procedure RedrawPoints();
    procedure DrawPoint(p: integer);
    function Nearest(x, y: integer): point;
    { Private declarations }
  public
    { Public declarations }
  end;

const
psize = 3;
var
  Form1: TForm1;
  points: array[0..9999] of point;
  map: array[0..1023, 0..767] of integer;
  curPoint, numPoint: integer;
  mdown, moved: boolean;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  f: textfile;
  c: char;
  x, y: integer;
  col: cardinal;
  w, h: integer;
  line: string;
  l: integer;
begin
  numPoint:= 0;
  mdown:= false;
  Image1.Canvas.Brush.Color:= $FF5020;
  Image1.canvas.Brush.Style:= bsSolid;

  assignfile (f, 'c:\1_simple.trk');
  reset (f);

  x:= 0;
  y:= 0;
  readln (f, w);
  readln (f, h);
  while (NOT eof(f)) do
  begin
    readln (f, line);
    for l:= 1 to w do
    begin
      c:= line[l];
      col:= $FFFF00;
      case c of
        '.' : col:= $808080;
        '!' : col:= $00A0FF;
        '*' : col:= $FF00FF;
        'g' : col:= $00FF00;
        'r' : col:= $0000FF;
        'w' : col:= $FFFFFF;
        'b' : col:= $FF0000;
      end;
      if (y<h) then
      begin
        image1.Canvas.Pixels[x,y]:= col;
        map[x,y]:= col;
      end;
      inc(x);
      if (x=w) then
      begin
        x:= 0;
        inc(y);
      end;
    end;
  end;
  closefile (f);
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
l: integer;
p: point;
begin
  curPoint:= -1;
  moved:= false;

  if (Button=mbRight) then
  begin
    p:= Nearest(X, Y);
    if (map[p.x,p.y]=$808080) then
    begin
      points[numPoint]:= p;
      DrawPoint(numPoint);
      inc(numPoint);
    end;
  end
  else if (Button=mbLeft) then
  begin
    mdown:= true;
    for l:= 0 to numPoint-1 do
    begin
      if ((abs(points[l].x-x)<=psize) AND (abs(points[l].y-y)<=psize)) then
        curPoint:= l;
    end;
  end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
oldx, oldy: integer;
i, j: integer;
p: point;
begin
  if ((mdown=true) AND (curPoint<>-1)) then
  begin
    oldx:= points[curPoint].X;
    oldy:= points[curPoint].Y;
    for i:= oldx-psize to oldx+psize do
      for j:= oldy-psize to oldy+psize do
        Image1.Canvas.Pixels[i,j]:= map[i,j];

    p:= Nearest(x, y);
    if (map[p.x,p.y]=$808080) then
      points[curPoint]:= p;

    DrawPoint(curPoint);
    moved:= true;
  end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  mdown:= false;
  if (moved=true) then
  begin
    moved:= false;
    //RedrawPoints();
  end;
end;

procedure TForm1.RedrawPoints();
var
  l: integer;
begin
  for l:= 0 to numPoint-1 do
  begin
    DrawPoint(l);
  end;
end;

procedure TForm1.DrawPoint(p: integer);
var
  x,y: integer;
begin
  x:= points[p].x;
  y:= points[p].y;
  Image1.Canvas.Ellipse(X-psize, Y-psize, X+psize, Y+psize);
  Image1.canvas.FloodFill(X, Y, $FF5020, fsBorder);
end;

function TForm1.Nearest (x, y: integer): point;
var
i,j, k: integer;
p: point;
dist: real;
begin
  k:= 15;
  dist:= 1000;
  p.x:= x;
  p.y:= y;
  for i:= x-k to x+k do
    for j:= y-k to y+k do
    begin
      if (map[i, j]=$808080) AND (sqr(x-i)+sqr(y-j)<dist) then
      begin
        p.x:= i;
        p.y:= j;
        dist:= sqr(x-i)+sqr(y-j);
      end
    end;
  Nearest:= p;
end;

end.
