import java.awt.*;
import java.awt.image.*;

public class MonkeyChecker
{
  static final boolean debug = true;
  BufferedImage map;

  public MonkeyChecker( String file )
  { map = MapViewer.getImageFromFile( file ); }

  public boolean isSmashed( double mx, double my )
  {
    int x = (int)mx, y = (int)my;
    int col = map.getRGB(x,y) & 0x00FFFFFF;
    if (debug) System.out.println("col("+Integer.toHexString(col)+") vs map("+
        Integer.toHexString(map.getRGB(x,y))+")");
    try
    {
      if (col == MapViewer.ROAD) return false;
      if (col == MapViewer.START) return false;
      if (col == MapViewer.FINISH) return false;
    }
    catch (Exception e)
    {
      System.out.println("Damn those monkeys!\n\t");
      e.printStackTrace();
      System.exit(42);
    }
    return true;
  }

  public boolean isSmashed( Point p )
  { return isSmashed(p.getX(),p.getY()); }
  
  
}
