import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.ArrayList;

public class Pixie extends Frame implements WindowListener, Runnable
{
  public static final int BLOWUP = 512;
  public static final int PSIZE = 2;
  public static final int REFRESH_TIME = 50;

  public void redrawImage()
  {
    Insets insets = getInsets();
    getGraphics().drawImage(image,insets.left,insets.top,this);
  }
  
  BufferedImage image;
  Thread me;
  public Pixie(ArrayList pts)
  {
    super("Pixel viewer");
    if (pts == null) pts = new ArrayList();
    image = new BufferedImage(BLOWUP,BLOWUP,BufferedImage.TYPE_INT_RGB);
    for (int i=0; i<BLOWUP; i++)
      for (int j=0; j<BLOWUP; j++)
        image.setRGB(i,j,MapViewer.ROAD);

    if (pts != null) for (int i=0; i<pts.size(); i++)
    {
      int x = (((int)((Point)pts.get(i)).getX()) >> 7) & 0x1ff;
      int y = (((int)((Point)pts.get(i)).getY()) >> 7) & 0x1ff;
      image.setRGB(x,y,MapViewer.PLANP);
    }
    setVisible(true);
    Insets i=getInsets();
    setSize(BLOWUP+i.left+i.right,BLOWUP+i.top+i.bottom);
    getGraphics().drawImage(image,i.left,i.top,this);
    addWindowListener(this);
    me = new Thread(this);
    me.start();

  }

  public void run()
  {
    try
    {
      while (true)
      { 
        redrawImage(); 
        Thread.sleep(REFRESH_TIME); 
      }
    }
    catch (Exception e) 
    { 
      System.out.println("Run terminated: "+e); 
      e.printStackTrace(); 
    }
  }


  public void windowClosing(WindowEvent e)
  { me.interrupt(); dispose(); }
  
  // I don't care about these events, but I have to implement them
  // because I'm a WindowListener.
  public void windowOpened(WindowEvent e){}
  public void windowClosed(WindowEvent e){}
  public void windowIconified(WindowEvent e){}
  public void windowDeiconified(WindowEvent e){}
  public void windowActivated(WindowEvent e) {}
  public void windowDeactivated(WindowEvent e){}
}
